% Program by Natalie from April 2014 to treat the Stark effect data on
% airbook Matlab 2013.

%load data
clear;
samplename=input('Please specifiy sample name ','s');%give name of file (without.txt)
filename=strcat(samplename,'.txt');
scans=input('Please specifiy number of scans ');%give number of scans
Data_all_t=importdata(filename);
Data_all=Data_all_t';
nwavelengths=size(Data_all,1)-2;
ntimes_all=size(Data_all,2)-1;
%ntimes=ntimes_all/(scans+1);
%uncomment below when considering only one scan. And obviously comment the
%above.
ntimes=ntimes_all;

%create new folder to store data
mkdir(samplename);

%prepare timedelay and save
timedelay(1,:)=Data_all(1,2:ntimes+1);
Timedelay_ps=timedelay';
timedelay_fs(1,:)=timedelay(1,:)*100;
timedelay_fs =round(timedelay_fs);
timedelay_fs=timedelay_fs*10; % round to the nearest 10 fs
timedelay_fs=timedelay_fs';
timedelay_ps_1=timedelay_fs/1000;
td_name=strcat('timedelay_',samplename);% name of file to save
td_path=strcat(samplename,'/','timedelay_',samplename);% path of file to save
fid = fopen(td_path, 'w'); %open file for writing
fprintf(fid, '%s', td_name);
fprintf(fid, '\n');
for i=1:ntimes 
    fprintf(fid, '%g', Timedelay_ps(i));
    fprintf(fid, '\n');
end
fclose(fid);

%prepare wavelength and save
Wavelength_nm(:,1)=Data_all(3:nwavelengths+2,1);
Wavelength_nm=Wavelength_nm.*10;
Wavelength_nm=round(Wavelength_nm);% round to the nearest 0.1 nm
Wavelength_nm=Wavelength_nm./10;
wl_name=strcat('wavelength_',samplename);% name of file to save
wl_path=strcat(samplename,'/','wavelength_',samplename);% path of file to save
fid = fopen(wl_path, 'w'); %open file for writing
fprintf(fid, '%s', wl_name);
fprintf(fid, '\n');
for i=1:nwavelengths
    fprintf(fid, '%g', Wavelength_nm(i));
    fprintf(fid, '\n');
end
fclose(fid);

%prepare data matrices and test plot
%a=input('Specify display time in ps ');%display time
%t=find(Timedelay_ps==a);
%b=input('Specify display wavelength in nm ');%display wavelength
%wl=find(Wavelength_nm==b);
bg=input('Do you want to subtract background (Y=1/N=0)? ');%background?
    if bg==1
        n_bg=input('How many background spectra do you want to subtract? ');
    end
%cc=hsv(12);
%figure
%hold on
for i=1:scans
    Data(1:nwavelengths,1:ntimes)=Data_all(2:nwavelengths+1,ntimes*(i-1)+2:ntimes*i+1);
    Data_t=Data';
    if bg==1
        background=mean(Data_t(1:n_bg,1:nwavelengths));
        for h=1:ntimes 
            for j=1:nwavelengths
       Data_corr(h,j)=Data_t(h,j)-background(1,j); 
            end
        end
   else
        Data_corr=Data_t;
    end
    s=['Data_' num2str(i) '=Data_corr;'];
    eval(s);
  %  plot(Wavelength_nm,Data_corr(t,:),'color',cc(i,:));
  %  plot(Timedelay_ps,Data_corr(:,wl),'color',cc(i,:));
  end
hold off%

%average wanted scans
how_many=input('How many scans do you want to average? ');
for i=1:how_many
    which_scans(i,1)=input('Which scans do you want to average? ');  
    scan_name=strcat('Data_',num2str(which_scans(i)));
    v = eval(scan_name);
    Data_cell{i}=cat(3,v); 
end
dim = ndims(Data_cell{1});          
M = cat(dim+1,Data_cell{:});        
Data_av = mean(M,dim+1); 

%make output files
% 1) Spectra (averaged)
Data_av_path=strcat(samplename,'/','Spectra_',samplename);% path of file to save
Data_av=Data_av';
Spectra_label=[];
for i=1:ntimes
    Spectra_label=strvcat(Spectra_label, ['sp_',samplename,'_',num2str(timedelay_ps_1(i)),'ps']);
end
Spectra_label=cellstr(Spectra_label);
fid = fopen(Data_av_path, 'w'); %open file for writing
for i = 1:ntimes
    LabelString = cell2mat(Spectra_label(i)); 
    fprintf(fid, '%s\t', LabelString);
end
fprintf(fid, '\n');
for j=1:nwavelengths 
    for i=1:ntimes
    fprintf(fid, '%e\t', Data_av(j,i));
    end
    fprintf(fid, '\n');
end
fclose(fid);
% 2) Dynamics (averaged)
Data_dyn_path=strcat(samplename,'/','Dyn_',samplename);% path of file to save
Data_av=Data_av';
Dyn_label=[];
for i=1:nwavelengths
    Dyn_label=strvcat(Dyn_label, ['dyn_',samplename,'_',num2str(Wavelength_nm(i)),'nm']);
end
Dyn_label=cellstr(Dyn_label);   
fid = fopen(Data_dyn_path, 'w'); %open file for writing
for i = 1:nwavelengths
    LabelString = cell2mat(Dyn_label(i)); 
    fprintf(fid, '%s\t', LabelString);
end
fprintf(fid, '\n');
for j=1:ntimes 
    for i=1:nwavelengths
    fprintf(fid, '%e\t', Data_av(j,i));
    end
    fprintf(fid, '\n');
end
fclose(fid);

% optional chirp correction
chirp=input('Do you want to chirp correct (Y=1/N=0)? ');%chirp
 if chirp==1
%give chirp parameters (exponential fit)
disp('Chirp parameters from exponential fit');
y0=input('indicate y0 ');
A=input('indicate A ');
tau=input('indicate tau ');
x0=input('indicate x0 '); % this is a constant automatically generated by Igor
%create shifted timedelays
td_x=[];
td_x(1:nwavelengths,1:ntimes)=0;
for i=1:nwavelengths
    zero=y0+A.*exp(-(Wavelength_nm(i)-x0)./tau);
    for j=1:ntimes
    td_x(i,j) = timedelay(j)-zero;
    end
end
td_x=td_x';
%interpolate for chirp correction
Data_chirp=[];
Data_chirp(1:ntimes,1:nwavelengths)=0;
for i=1:nwavelengths
Data_chirp(:,i)=interp1(td_x(:,i),Data_av(:,i),timedelay,'pchip');
end
% save chirp-corrected spectra
Data_chirp_path=strcat(samplename,'/','Chirp_',samplename);% path of file to save
Data_chirp=Data_chirp';
Spectra_label=[];
for i=1:ntimes
    Spectra_label=strvcat(Spectra_label, ['c_',samplename,'_',num2str(timedelay_ps_1(i)),'ps']);
end
Spectra_label=cellstr(Spectra_label);
fid = fopen(Data_chirp_path, 'w'); %open file for writing
for i = 1:ntimes
    LabelString = cell2mat(Spectra_label(i)); 
    fprintf(fid, '%s\t', LabelString);
end
fprintf(fid, '\n');
for j=1:nwavelengths 
    for i=1:ntimes
    fprintf(fid, '%e\t', Data_chirp(j,i));
    end
    fprintf(fid, '\n');
end
fclose(fid);
% save chirp-corrected dynamics
Data_cdyn_path=strcat(samplename,'/','Cdyn_',samplename);% path of file to save
Data_chirp=Data_chirp';
Cdyn_label=[];
for i=1:nwavelengths
    Cdyn_label=strvcat(Cdyn_label, ['cdyn_',samplename,'_',num2str(Wavelength_nm(i)),'nm']);
end
Cdyn_label=cellstr(Cdyn_label);   
fid = fopen(Data_cdyn_path, 'w'); %open file for writing
for i = 1:nwavelengths
    LabelString = cell2mat(Cdyn_label(i)); 
    fprintf(fid, '%s\t', LabelString);
end
fprintf(fid, '\n');
for j=1:ntimes 
    for i=1:nwavelengths
    fprintf(fid, '%e\t', Data_chirp(j,i));
    end
    fprintf(fid, '\n');
end
fclose(fid);
% save chirp-corrected timedelays
Data_td_path=strcat(samplename,'/','TD_',samplename);% path of file to save
TD_label=[];
for i=1:nwavelengths
    TD_label=strvcat(TD_label, ['td_',samplename,'_',num2str(Wavelength_nm(i)),'nm']);
end
TD_label=cellstr(TD_label);   
fid = fopen(Data_td_path, 'w'); %open file for writing
for i = 1:nwavelengths
    LabelString = cell2mat(TD_label(i)); 
    fprintf(fid, '%s\t', LabelString);
end
fprintf(fid, '\n');
for j=1:ntimes 
    for i=1:nwavelengths
    fprintf(fid, '%e\t', td_x(j,i));
    end
    fprintf(fid, '\n');
end
fclose(fid);
 end
 
close all
disp('For loading this data in IGOR use the following command:');
disp('loadwave/g/a/w');




